/*
 *  Copyright (c) 2018 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.teamvento.generator;

import org.bukkit.World;
import org.bukkit.WorldCreator;
import org.bukkit.WorldType;

/**
 * @author joethei
 * @version 1.0
 */
public class GeneratorManager {

    public static WorldCreator getWorldCreator(String name, String generator) {
        WorldCreator creator = new WorldCreator(name);
        switch (generator) {
            case "normal":
                creator.environment(World.Environment.NORMAL);
                creator.type(WorldType.NORMAL);
                break;
            case "flat":
                creator.environment(World.Environment.NORMAL);
                creator.type(WorldType.FLAT);
                creator.generateStructures(false);
                break;
            case "void":
                creator.generator(new VoidGenerator());
                creator.type(WorldType.CUSTOMIZED);
                creator.generateStructures(false);
                break;
            case "water":
                creator.generator(new WaterGenerator());
                creator.type(WorldType.CUSTOMIZED);
                creator.generateStructures(false);
                break;
            case "dev":
                creator.generator(new DevGenerator());
                creator.type(WorldType.CUSTOMIZED);
                creator.generateStructures(false);
                break;
            case "custom":
                creator.generator(new CustomGenerator());
                creator.type(WorldType.CUSTOMIZED);
                creator.generateStructures(false);
                break;
            default:
                return null;
        }

        return creator;
    }
}