/*
 *  Copyright (c) 2018 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.teamvento.plot;

import eu.univento.core.api.items.ItemBuilder;
import eu.univento.core.api.player.CustomPlayer;
import org.bukkit.Bukkit;
import org.bukkit.Color;
import org.bukkit.DyeColor;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.material.Dye;

/**
 * @author joethei
 * @version 1.0
 */

public class InventoryManager {

    private final CustomPlayer player;

    public InventoryManager(CustomPlayer player) {
        this.player = player;
    }

    public Inventory getPlayerInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eGrundstücksverwaltung");

        //inv.setItem(0, new ItemBuilder(player, Material.MINECART).name("§eZu anderen Plots teleportieren").build());
        //inv.setItem(8, new ItemBuilder(player, Material.LADDER).name("§eEinstellungen").build());
        inv.setItem(1, new ItemBuilder(Material.WATCH).name("§eZeit ändern").build());
        inv.setItem(7, new ItemBuilder(Material.DOUBLE_PLANT).durability((short) 4).name("§eBiom ändern").build());
        inv.setItem(13, new ItemBuilder(Material.BED).durability((short) 8).name("§ezu deinem Grundstück").build());
        inv.setItem(19, new ItemBuilder(Material.DOUBLE_PLANT).name("§eWetter ändern").build());
        //inv.setItem(20, new ItemBuilder(player, Material.SKULL_ITEM).durability((short) 3).skullOwner("conorf1807").build());

        Dye resetDye = new Dye();
        resetDye.setColor(DyeColor.RED);
        ItemStack reset = resetDye.toItemStack(1);
        ItemMeta resetMeta = reset.getItemMeta();
        resetMeta.setDisplayName("§eGrundstück zurücksetzen");
        reset.setItemMeta(resetMeta);

        Dye readyDye = new Dye();
        readyDye.setColor(DyeColor.LIME);
        ItemStack ready = readyDye.toItemStack(1);
        ItemMeta readyMeta = ready.getItemMeta();
        readyMeta.setDisplayName("§eFertig");
        ready.setItemMeta(readyMeta);

        inv.setItem(25, reset);
        //inv.setItem(26, ready);

        return inv;
    }

    public Inventory getReadyInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§ePlot fertig ?");

        inv.setItem(5, new ItemBuilder(Material.WOOL).color(Color.LIME).name("Ja").build());
        inv.setItem(10, new ItemBuilder(Material.WOOL).color(Color.RED).name("Nein").build());

        return inv;
    }

    public Inventory getBiomeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eBiom ändern");

        inv.setItem(0, new ItemBuilder(Material.STAINED_CLAY).durability((short) 1).name("§eMesa").build());
        inv.setItem(4, new ItemBuilder(Material.SAPLING).durability((short) 3).name("§eDschungel").build());
        inv.setItem(8, new ItemBuilder(Material.WATER_LILY).name("§eSumpfgebiet").build());
        inv.setItem(11, new ItemBuilder(Material.SAPLING).name("§eWald").build());
        inv.setItem(15, new ItemBuilder(Material.LONG_GRASS).durability((short) 1).name("§eFlachland").build());
        inv.setItem(18, new ItemBuilder(Material.DEAD_BUSH).name("§eWüste").build());
        inv.setItem(22, new ItemBuilder(Material.SNOW_BALL).name("§eTundra").build());
        inv.setItem(26, new ItemBuilder(Material.SAPLING).name("§eTaiga").durability((short) 1).build());

        return inv;
    }

    public Inventory getSettingsInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eEinstellungen");

        inv.setItem(10, new ItemBuilder(Material.SIGN).name("§eName ändern").build());
        inv.setItem(16, new ItemBuilder(Material.NAME_TAG).name("§eKontaktmöglichkeiten").build());

        return inv;
    }

    public Inventory getTimeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eZeit ändern");

        inv.setItem(10, new ItemBuilder(Material.MILK_BUCKET).name("§eMorgen").build());
        inv.setItem(12, new ItemBuilder(Material.DOUBLE_PLANT).name("§eTag").build());
        inv.setItem(14, new ItemBuilder(Material.BEETROOT_SOUP).name("§eAbend").build());
        inv.setItem(16, new ItemBuilder(Material.COAL).name("§eNacht").durability((short) 1).build());

        return inv;
    }

    public Inventory getWeatherInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eWetter ändern");

        inv.setItem(11, new ItemBuilder(Material.DOUBLE_PLANT).name("§eSonne").build());
        inv.setItem(13, new ItemBuilder(Material.WATER_BUCKET).name("§eRegen").build());
        inv.setItem(15, new ItemBuilder(Material.BLAZE_ROD).name("§eGewitter").build());

        return inv;
    }

}